<!--
  Copyright: (c) 2020-2021, VTK Gent vzw
  GNU Affero General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/agpl-3.0.txt)
-->

<template>
  <v-container class="pa-0 ma-0" style="width: 100%">
    <!-- Editor -->
    <v-row no-gutters>
      <v-col cols="12">
        <client-only>
          <lazy-tiptap-editor v-model="content" />
        </client-only>
      </v-col>
    </v-row>

    <!-- Actions -->
    <v-row class="pt-6" no-gutters justify="end">
      <!-- Save -->
      <v-btn
        class="studium-button"
        color="primary"
        text
        large
        :ripple="false"
        :loading="editContentMutation.loading.value"
        @click="onSave"
      >
        {{ $t('courses.description.editor.save') }}
      </v-btn>

      <!-- Cancel -->
      <v-btn class="studium-button" color="secondary" text large :ripple="false" @click="onCancel">
        {{ $t('courses.description.editor.cancel') }}
      </v-btn>
    </v-row>
  </v-container>
</template>

<script>
import { defineComponent, onMounted, ref } from '@nuxtjs/composition-api'

export default defineComponent({
  props: {
    // Mutation to edit the content
    editContentMutation: {
      type: Object,
      required: true,
    },

    // Current course description value
    courseDescription: {
      type: String,
      default: '',
    },

    // Course code
    courseCode: {
      type: String,
      default: '',
    },
  },
  setup(props, { emit }) {
    // Initial content of the editor
    const content = ref(props.courseDescription)

    // Reset the content  to the prop value on mounted
    onMounted(() => (content.value = props.courseDescription))

    // If the editContentMutation is successful, emit the close event
    props.editContentMutation.onDone(() => emit('close'))

    // "save" button event handler
    function onSave() {
      // Attempt to mutate the content
      props.editContentMutation.mutate({
        code: props.courseCode,
        content: content.value,
      })
    }

    // "cancel" button event handler.
    function onCancel() {
      // Emit the close event
      emit('close')
    }

    return {
      content,
      onSave,
      onCancel,
    }
  },
})
</script>

<style lang="scss" scoped>
.cancelButton {
  background-color: $background !important;
  border-radius: 3px;
  $body-font-family: 'Montserrat', sans-serif;
  align-items: center;
  text-align: center;
  padding-right: 8px !important;
  padding-left: 8px !important;
  width: 90px;
  margin-top: 4px;
  box-shadow: none;
}

.edit-button {
  // position: absolute;
  // right: 0;
  // margin-top: 12px;
  float: right;
}

.placeholder {
  background-image: url('/util/placeholder_brackets.svg');
  background-position: center;
  background-size: 100% 100%;
  width: 100%;
  height: auto;
  min-height: 400px;
  margin: 0 auto;
  text-align: center;
  justify-items: center;
  justify-self: center;
}

.nothingHere {
  color: $secondary;
  font-size: 36px;
}

// Same css as the " Add your courses here" on the empty my course page
.startSharing {
  font-size: 24px;

  @media #{map-get($display-breakpoints, 'xs-only')} {
    font-size: 16px;
  }

  color: $secondary;
  text-decoration-color: $secondary;
  text-decoration: underline;
}

.startSharing:hover {
  color: #111b47;
  text-decoration-color: #111b47;
  cursor: pointer;
}
</style>
